-- Autor Lechu
-- fixes: Ziuta (17.04.2014)
 
Ursus1014Nm= {};
 
function Ursus1014Nm.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
 
function Ursus1014Nm:load(xmlFile)

	-- Motor rpm
	self.motorSoundPitchOffsetSave = self.motorSoundPitchOffset;


	local klapalewa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lok#lewe"));
	if klapalewa ~= nil then
		self.klapalewa = klapalewa;
	end;
		local klapaprawa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lok#prawe"));
	if klapaprawa ~= nil then
		self.klapaprawa = klapaprawa;
	end;
		local zaczep = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lok#zaczep"));
	if zaczep ~= nil then
		self.zaczep = zaczep;
	end;
		local zdejmijzaczep = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lok#zdejmijzaczep"));
	if zdejmijzaczep ~= nil then
		self.zdejmijzaczep = zdejmijzaczep;
	end;
    local rotationPartNodepedalgazu = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pedal_gazu#index"));
    if rotationPartNodepedalgazu ~= nil then
        self.rotationPartpedalgazu = {};
        self.rotationPartpedalgazu.node = rotationPartNodepedalgazu;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_gazu#minRot"));
        self.rotationPartpedalgazu.minRot = {};
        self.rotationPartpedalgazu.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalgazu.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalgazu.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_gazu#maxRot"));
        self.rotationPartpedalgazu.maxRot = {};
        self.rotationPartpedalgazu.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalgazu.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalgazu.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpedalgazu.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_gazu#rotTime"), 2)*1000;
        self.rotationPartpedalgazu.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_gazu#touchRotLimit"), 10));
    end;
	local rotationPartNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart3#index"));
		if rotationPartNode3 ~= nil then
        self.rotationPart3 = {};
        self.rotationPart3.node = rotationPartNode3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#minRot"));
        self.rotationPart3.minRot = {};
        self.rotationPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#maxRot"));
        self.rotationPart3.maxRot = {};
        self.rotationPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#rotTime"), 2)*1000;
        self.rotationPart3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#touchRotLimit"), 10));
    end;

	local rotationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
    if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
    end;
	self.rotationMax3Active = false;
	self.rotationMax2Active = false;  
		
    local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);
    self.hydraulics = {};
    for i=1, hydraulicsCount do
        local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);
        self.hydraulics[i] = {};
        self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
        self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
        self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
        self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));
        local xUp, yUp, zUp = Utils.getVectorFromString(Utils.getNoNil(getXMLString(xmlFile, hydraulicName .. "#upVectors"),"0 1 0"));
        self.hydraulics[i].upVectors = {xUp, yUp, zUp};
 
        local ax, ay, az;
        if self.hydraulics[i].punch ~= nil then
            ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
        else
            ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
        end;
        if self.hydraulics[i].translationPunch ~= nil then
            local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);
            self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
        end;
	end;
    self.setHydraulicTime = 30;
    self.setHydraulicDirection = SpecializationUtil.callSpecializationsFunction("setHydraulicDirection");

    local rotationLifter = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Lifter#index"));
    self.Lifter = {};
    self.Lifter.node = rotationLifter;
 
    local rotationLifterArm = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.LifterArm#index"));
    self.LifterArm = {};
    self.LifterArm.node = rotationLifterArm;
 
    local rotationLifterBottom = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.LifterBottom#index"));
    self.bottomArm2 = {};
    self.bottomArm2.node = rotationLifterBottom;

	self.rollNodes = {};

    local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roll#index"));
    if rollNode ~= nil then
        local speed = 0.003*3;
        table.insert(self.rollNodes, {node=rollNode, speed=speed});
    end;
    local i = 0;
    while true do
        local key = string.format("vehicle.rolls.roll(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local speed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#speed"), 0.003);
        if rollNode ~= nil then
            table.insert(self.rollNodes, {node=rollNode, speed=speed});
        end;
        i = i + 1;
	end;

	self.blysk = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kogut#index"));
	self.blysk2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.HP#index"));
	self.blysk3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.HT#index"));
end;

function Ursus1014Nm:delete()
end;
 
function Ursus1014Nm:mouseEvent(posX, posY, isDown, isUp, button)
end;
 
function Ursus1014Nm:keyEvent(unicode, sym, modifier, isDown) 
	if isDown and sym == Input.KEY_b then
		self.wajcha = not self.wajcha;
	end;

	if isDown and sym == Input.KEY_z then
		self.wycieraczka = not self.wycieraczka;
	end;
	
	if isDown and sym == Input.KEY_z then
		self.wlacznik = not self.wlacznik;
	end;

	if isDown and sym == Input.KEY_home then
		self.kogut = not self.kogut;
	end;

	if isDown and sym == Input.KEY_home then
		self.wlacznik2 = not self.wlacznik2;
	end;

	if isDown and sym == Input.KEY_5 then
		self.Halogen1 = not self.Halogen1;
	end;

	if isDown and sym == Input.KEY_5 then
		self.wlacznik3 = not self.wlacznik3;
	end;

	if isDown and sym == Input.KEY_6 then
		self.wlacznik4 = not self.wlacznik4;
	end;
	if isDown and sym == Input.KEY_6 then
		self.Halogen2 = not self.Halogen2;
	end;
end;
 
function Ursus1014Nm:update(dt)

	  --napisy
		if self.przyzaczepie then
			g_currentMission:addHelpButtonText(g_i18n:getText("RearHitchUp"), InputBinding.zaczepUp);
			g_currentMission:addHelpButtonText(g_i18n:getText("RearHitchDown"), InputBinding.zaczepDown);
		end;
		if self.przyklapiel then
	    if self.animationParts[2].clipStartTime then
			g_currentMission:addHelpButtonText(g_i18n:getText("DoorOpen"), InputBinding.d_lewe);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("DoorClose"), InputBinding.d_lewe);
		end;
		end;
		if self.przyklapiep then
	    if self.animationParts[1].clipStartTime then
			g_currentMission:addHelpButtonText(g_i18n:getText("DoorOpen"), InputBinding.d_prawe);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("DoorClose"), InputBinding.d_prawe);
		end;
		end
		if self.przyzaczepie2 then
			g_currentMission:addHelpButtonText(g_i18n:getText("RearHitchshowUp"), InputBinding.zaczepUp);
			g_currentMission:addHelpButtonText(g_i18n:getText("RearHitchshowDown"), InputBinding.zaczepDown);
		end;

        local nearestDistance = 2;
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
	
		
		local px, py, pz = getWorldTranslation(self.klapalewa); 
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.przyklapiel = true; 
		else
			self.przyklapiel = false; 
		end;
		
		local rx, ry, rz = getWorldTranslation(self.klapaprawa); 
		local distance = Utils.vector3Length(rx-vx, ry-vy, rz-vz);	
		if distance < nearestDistance then
			self.przyklapiep = true; 
		else
			self.przyklapiep = false; 
		end;


		local sx, sy, sz = getWorldTranslation(self.zaczep); 
		local distance = Utils.vector3Length(sx-vx, sy-vy, sz-vz);	
		if distance < nearestDistance then
			self.przyzaczepie = true; 
		else
			self.przyzaczepie = false; 
		end; 

		local sx, sy, sz = getWorldTranslation(self.zdejmijzaczep); 
		local distance = Utils.vector3Length(sx-vx, sy-vy, sz-vz);	
		if distance < nearestDistance then
			self.przyzaczepie2 = true; 
		else
			self.przyzaczepie2 = false; 
		end; 

--------drzwi----------------
--otwieranie--
	if self.przyklapiep or self.isEntered then
	if InputBinding.hasEvent(InputBinding.d_prawe) then
			if self.animationParts[1].clipEndTime then
				self:setAnimationTime(1, self.animationParts[1].offSet);
			elseif self.animationParts[1].clipStartTime then
				self:setAnimationTime(1, self.animationParts[1].animDuration);
			end;
		end;
	end;

	if self.przyklapiel or self.isEntered then
	if InputBinding.hasEvent(InputBinding.d_lewe) then
			if self.animationParts[2].clipEndTime then
				self:setAnimationTime(2, self.animationParts[2].offSet);
			elseif self.animationParts[2].clipStartTime then
				self:setAnimationTime(2, self.animationParts[2].animDuration);
			end;
		end;
	end;  

	--zaczep--
	if self.przyzaczepie then
	 	if InputBinding.isPressed(InputBinding.zaczepUP) then
               self:setAnimationTime(12, self.animationParts[12].currentPosition+(self.animationParts[12].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.zaczepDW) then
               self:setAnimationTime(12, self.animationParts[12].currentPosition-(self.animationParts[12].offSet+dt), false);
        end;
        end;			

	--zdejmijzaczep--
	if self.przyzaczepie2 then
	 	if InputBinding.isPressed(InputBinding.zdejmijzaczepUP) then
               self:setAnimationTime(13, self.animationParts[13].currentPosition+(self.animationParts[13].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.zdejmijzaczepDW) then
               self:setAnimationTime(13, self.animationParts[13].currentPosition-(self.animationParts[13].offSet+dt), false);
        end;
        end;

	if self.isMotorStarted then
		if self.isEntered then
		if self.wajcha then
			self:setAnimationTime(16,self.animationParts[16].animDuration);
		else
			self:setAnimationTime(16,self.animationParts[16].offSet);
		end;
		end;
        end;
				
		if  self.isEntered then				
		if  self.lewy then
			self:setAnimationTime(14,self.animationParts[14].animDuration);
			self.right = false;
		else
			self:setAnimationTime(14,self.animationParts[14].offSet);
		end;
        end;
        if  self.isEntered then		
 		if  self.prawy then
			self:setAnimationTime(15,self.animationParts[15].animDuration);
			self.left = false;
		else
			self:setAnimationTime(15,self.animationParts[15].offSet);
		end;
        end;

	    if self.handbrake then
		    self:setAnimationTime(17,self.animationParts[17].animDuration);
		else
			self:setAnimationTime(17,self.animationParts[17].offSet);
		end;


                                       ---wycieraczka---
		if self.wycieraczka then
           self:setAnimationTime(18, 1);
        else
           self:setAnimationTime(18, 0);
        end;
		
		if self.isEntered then
		if self.wlacznik then
			self:setAnimationTime(19,self.animationParts[19].animDuration);
		else
			self:setAnimationTime(19,self.animationParts[19].offSet);
		end;
		end;
									   ---wycieraczka end--- 

                                       ---kogut---
                if self.kogut then
	   self:setAnimationTime(23, 1);
	   setVisibility((self.blysk), true);
	else
	   self:setAnimationTime(23, 0);
	   setVisibility((self.blysk), false);
	end;

		if self.isEntered then
		if self.wlacznik2 then
			self:setAnimationTime(20,self.animationParts[20].animDuration);
		else
			self:setAnimationTime(20,self.animationParts[20].offSet);
		end;
		end;
									   ---kogut end--- 

                                       ---Halogensy---	
                if self.Halogen1 then
	   setVisibility((self.blysk2), true);
	else
	   setVisibility((self.blysk2), false);
	end;

		if self.isEntered then
		if self.wlacznik3 then
			self:setAnimationTime(21,self.animationParts[21].animDuration);
		else
			self:setAnimationTime(21,self.animationParts[21].offSet);
		end;
		end;

                if self.Halogen2 then
	   setVisibility((self.blysk3), true);
	else
	   setVisibility((self.blysk3), false);
	end;

		if self.isEntered then
		if self.wlacznik4 then
			self:setAnimationTime(22,self.animationParts[22].animDuration);
		else
			self:setAnimationTime(22,self.animationParts[22].offSet);
		end;
		end;
									   ---Halogensy end--- 		
       
	if self.isMotorStarted then
		if Input.isKeyPressed(Input.KEY_w) or Input.isKeyPressed(Input.KEY_s) then
			self.rotationMaxpedalgazu = true;
		else
			self.rotationMaxpedalgazu = false;
	    end;
	end;	
	if self:getIsActive() then
		inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
		if InputBinding.isAxisZero(inputAxisY) then
			inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
		end;
		if self.isEntered ~= nil then
			if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then		
				self.rotationMax3Active = true;
				self.rotationMax2Active = true;
			else
				self.rotationMax3Active = false;
				self.rotationMax2Active = false;
			end;
		end;
		if self.rotationPart3 ~= nil then
			local x, y, z = getRotation(self.rotationPart3.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart3.maxRot, self.rotationPart3.minRot, 3, self.rotationPart3.rotTime, dt, not self.rotationMax3Active);
			setRotation(self.rotationPart3.node, unpack(newRot));
		end;
		if self.rotationPart2 ~= nil then
			local x, y, z = getRotation(self.rotationPart2.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime, dt, not self.rotationMax2Active);
			setRotation(self.rotationPart2.node, unpack(newRot));
		end;
		if self.rotationPartpedalgazu ~= nil then
			local x, y, z = getRotation(self.rotationPartpedalgazu.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpedalgazu.maxRot, self.rotationPartpedalgazu.minRot, 3, self.rotationPartpedalgazu.rotTime, dt, not self.rotationMaxpedalgazu);
			setRotation(self.rotationPartpedalgazu.node, unpack(newRot));
		end;		
	end;
	if self.isMotorStarted then
        for _, rollNode in pairs(self.rollNodes) do
			rotate(rollNode.node, 0, 0, -dt*rollNode.speed);
        end;
  
		if self.Lifter.node ~= nil and self.bottomArm2.node ~= nil then
            rBBArmX, rBBArmY, rBBArmZ = getRotation(self.bottomArm2.node);
            setRotation(self.Lifter.node, rBBArmX*1.5, 0, 0);
        end;
        if self.LifterArm.node ~= nil and self.bottomArm2.node ~= nil then
            setRotation(self.LifterArm.node, 0.05-rBBArmX*1.5, 0, 0);
        end;
        
		if self:getIsActive() then
            self.setHydraulicTime = 30;
        end; 
 
        if self.setHydraulicTime > 0 then
            for k,v in pairs(self.hydraulics) do
                self:setHydraulicDirection(k);
            end;
            self.setHydraulicTime = self.setHydraulicTime - 1;
        end;
		if self.isEntered then 
				if InputBinding.isPressed(InputBinding.SZYBA_UP) then
					self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet+dt), false);
				elseif InputBinding.isPressed(InputBinding.SZYBA_DOWN) then
					self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
				end;
				if InputBinding.isPressed(InputBinding.DACH_UP) then
					self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[3].offSet+dt), false);
				elseif InputBinding.isPressed(InputBinding.DACH_DOWN) then
					self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[3].offSet+dt), false);
				end;
				if InputBinding.hasEvent(InputBinding.BOCZNAL) then
					if self.animationParts[10].clipEndTime then
						self:setAnimationTime(10, self.animationParts[10].offSet);
					 elseif self.animationParts[10].clipStartTime then
							self:setAnimationTime(10, self.animationParts[10].animDuration);
					end;
				end;
				if InputBinding.hasEvent(InputBinding.BOCZNAP) then
					if self.animationParts[11].clipEndTime then
						self:setAnimationTime(11, self.animationParts[11].offSet);
					 elseif self.animationParts[11].clipStartTime then
							self:setAnimationTime(11, self.animationParts[11].animDuration);
					end;
				end;
			end;
		end
	end
	
function Ursus1014Nm:updateTick(dt)    
end;    

function Ursus1014Nm:onEnter()
end;

function Ursus1014Nm:draw() 
end; 

function Ursus1014Nm:attachImplement(implement)
end;

function Ursus1014Nm:detachImplement(implementIndex, noEventSend)
end;

function Ursus1014Nm:onLeave()
end;

function Ursus1014Nm:setHydraulicDirection(index)
    local hydraulic = self.hydraulics[index];
 
    if hydraulic.fixPoint ~= nil then
        local ax, ay, az = getWorldTranslation(hydraulic.node);
        local bx, by, bz = getWorldTranslation(hydraulic.fixPoint);
        local x, y, z = worldDirectionToLocal(getParent(hydraulic.node), bx-ax, by-ay, bz-az);
        local xUp, yUp, zUp = unpack(hydraulic.upVectors);
        setDirection(hydraulic.node, x, y, z, xUp, yUp, zUp);
        if hydraulic.punch ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            setTranslation(hydraulic.punch, 0, 0, distance-hydraulic.punchDistance);
        end;
    end;
end;
 
function Ursus1014Nm:updateTick(dt)
    if self.backHydraulic ~= nil then               
        local x, y, z = getRotation(self.attacherJoints[1].bottomArm.rotationNode);
        setRotation(self.backHydraulic.rootArm, x, y, z);       
    end;            
end;